# ----------------------------------------------------------------
#  testClient.py:
#
#
# ----------------------------------------------------------------
from rftClient import *

# ----------------------------------------------------------------
#  getNextCommand
# ----------------------------------------------------------------
def getNextCommand():
    while 1:
        for i in range(len(requests)): print " %d -  %s" %(i, requests[i])
        print " ---"
        try: x = int(raw_input('>'))
        except ValueError, ex: sys.exit(1)
        if( 9 >= x >= 0 ):
            break
    return requests[x]

# ----------------------------------------------------------------
#  main
# ----------------------------------------------------------------
def main():
   #----------------- set defaults -----------------
   port, namespace, proto, soap_protocol, debug = setDefaults()
   #----------------- Initialize -------------------
   soap_proxy = ''
   try:
        opt, arg = getopt.getopt(sys.argv[1:], 'h:p:d:')
   except getopt.error:
       print "Bad command-line arg [-p port][-h host]"
       sys.exit(-1)
   for o,a in opt:
        if o == '-p':
            port = int(a)
        elif o == '-h':
            soap_proxy = a
            soap_proxy = socket.gethostbyaddr(soap_proxy)
        elif o == '-d':
            debug = int(a)
   if debug > 4:
       print (("\tport = %s\n\tnamespace = %s\n\tproto = %s\n\tsoap_proto = %s"
               % (port, namespace, proto, soap_protocol)))
   # ----------------------------------------------------------------
   # ----------------------------------------------------------------
   if not soap_proxy:
       print "ERROR: Must provide [-h host]"
       sys.exit(-1)
   client = rftClient(soap_protocol, soap_proxy[0], port, namespace)
   handle = None
   # ----------------------------------------------------------------
   # ----------------------------------------------------------------
   while 1:
       print "--------------------------"
       cmd = getNextCommand()
       if ((cmd == 'completeTransferRequest')):
           handle = raw_input( 'Enter handle: ')
       elif((cmd == 'commitTransferRequest') or
           (cmd == 'listTransferRequest') or
           (cmd == 'checkStatusRequest') or
           (cmd == 'changePriorityRequest') or
           (cmd == 'clearRecordRequest') or
           (cmd == 'userStopTransferRequest')):
           tmp = raw_input(('Enter handle(%s): ' %(handle)))
           if tmp:
               handle = tmp
       if ((cmd == 'submitTransferRequest') or
           (cmd == 'completeTransferRequest')):
           priority = raw_input( 'Enter priority: ')
           src = raw_input( 'Enter source (host/file): ')
           dst = raw_input( 'Enter dest   (host/file): ')
       elif (cmd == 'changePriorityRequest'):
           priority = raw_input( 'Enter priority: ')

       # ----------------------------------------------------------------
       # ----------------------------------------------------------------
       try: 
           if   cmd == 'completeTransferRequest':
               tmp = client.completeTransferRequest(handle, proto, src,
                                                    dst, priority)
           elif cmd == 'submitTransferRequest':
               tmp = client.submitTransferRequest(proto, src, dst, priority)
               tmp = (('handle: %s') %(tmp))
           elif cmd == 'commitTransferRequest':
               tmp = client.commitTransferRequest(handle)
               tmp = (('handle: %s') %(tmp))
           elif cmd == 'listTransferRequest':
               tmp = client.listTransferRequest(handle)
           elif cmd == 'checkStatusRequest':
               tmp = client.checkStatusRequest(handle)
               tmp = (('status: %s') %(tmp))
           elif cmd == 'changePriorityRequest':
               tmp = client.changePriorityRequest(handle, priority)
               tmp = (('priority: %s') %(tmp))
           elif cmd == 'clearRecordRequest':
               client.clearRecordRequest(handle)
               tmp = cmd
           elif cmd == 'userStopTransferRequest': 
               tmp = client.userStopTransferRequest(handle)
               tmp = (('handle: %s') %(tmp))
           elif cmd == 'printDS': 
               client.printDS()
               tmp = cmd
           elif cmd == 'getDump':
               tmp = client.getDump()
           else:
               break
       except Exception, ex: 
           print "  Exception: ",ex
           traceback.print_exc()
       else:                 
           print tmp

if __name__=='__main__':
        main()
